'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _MapView = require('./mapview/MapView');

var _MapView2 = _interopRequireDefault(_MapView);

var _HomeButton = require('./reactors/HomeButton/HomeButton');

var _HomeButton2 = _interopRequireDefault(_HomeButton);

var _Geocoder = require('./reactors/Geocoder/Geocoder');

var _Geocoder2 = _interopRequireDefault(_Geocoder);

var _Bookmarks = require('./reactors/Bookmarks/Bookmarks');

var _Bookmarks2 = _interopRequireDefault(_Bookmarks);

var _LayerList = require('./reactors/LayerList/LayerList');

var _LayerList2 = _interopRequireDefault(_LayerList);

var _ListGroups = require('./reactors/ListGroups/ListGroups');

var _ListGroups2 = _interopRequireDefault(_ListGroups);

var _Showcase = require('./reactors/Showcase/Showcase');

var _Showcase2 = _interopRequireDefault(_Showcase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // Copyright (c) 2016 Yusuke Nunokawa (https://ynunokawa.github.io)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

var Mediator = function (_React$Component) {
  _inherits(Mediator, _React$Component);

  function Mediator(props) {
    _classCallCheck(this, Mediator);

    var _this = _possibleConstructorReturn(this, (Mediator.__proto__ || Object.getPrototypeOf(Mediator)).call(this, props));

    _this.state = {
      webmap: {},
      map: {},
      mapState: {
        center: [],
        zoom: 5,
        bounds: {}
      },
      initialCenter: [],
      initialZoom: 5,
      title: '',
      layers: [],
      bookmarks: [],
      portalItem: {},
      listGroups: {
        layer: {},
        layoutFields: {
          type: '',
          typeValues: [],
          name: '',
          label: '',
          sort: ''
        }
      },
      showcase: {
        layer: {},
        layoutFields: {
          name: '',
          description: '',
          image: '',
          imageUrlPrefix: '',
          sort: ''
        }
      }
    };
    return _this;
  }

  _createClass(Mediator, [{
    key: '_initMapEventListeners',
    value: function _initMapEventListeners() {
      var map = this.state.map;
      map.on('moveend', this._onMapMoveend, this);
    }
  }, {
    key: '_onMapMoveend',
    value: function _onMapMoveend(e) {
      var map = this.state.map;
      this.setState({
        mapState: {
          center: map.getCenter(),
          zoom: map.getZoom(),
          bounds: map.getBounds()
        }
      });
    }
  }, {
    key: '_initWebMap',
    value: function _initWebMap(map, mapid) {
      var webmap = L.esri.webMap(mapid, { map: map });
      webmap.on('load', function () {
        this.setState({
          webmap: webmap,
          map: map,
          mapState: {
            center: map.getCenter(),
            zoom: map.getZoom(),
            bounds: map.getBounds()
          },
          title: webmap.title,
          layers: webmap.layers,
          bookmarks: webmap.bookmarks,
          portalItem: webmap.portalItem
        });
        this._initMapEventListeners();
        this.setView = this.setView.bind(this);
        this.fitBounds = this.fitBounds.bind(this);
        this.readyComponents();
      }.bind(this));
      webmap.on('metadataLoad', function () {
        setTimeout(function () {
          this.setState({
            initialCenter: [map.getCenter().lat, map.getCenter().lng],
            initialZoom: map.getZoom()
          });
        }.bind(this), 500);
      }.bind(this));
    }
  }, {
    key: 'setView',
    value: function setView(center, zoom) {
      var map = this.state.map;
      map.setView(center, zoom);
    }
  }, {
    key: 'fitBounds',
    value: function fitBounds(bounds) {
      var map = this.state.map;
      map.fitBounds(bounds);
    }

    // You can 

  }, {
    key: 'readyComponents',
    value: function readyComponents() {
      var listGroupsLayerIndex = 2;
      var listGroupsLayoutFields = {
        type: '種別',
        typeValues: ['認可保育所', '認証保育所（A型）', '認証保育所（B型）'],
        name: '施設名',
        label: '定員',
        sort: '定員'
      };
      var showcaseLayerIndex = 4;
      var showcaseLayoutFields = {
        name: '場所名',
        description: '説明',
        image: '画像',
        imageUrlPrefix: 'https://muxlab.github.io/map-effects-100/data/img/',
        sort: 'NO_'
      };

      this.setState({
        listGroups: {
          layer: this.state.webmap.layers[listGroupsLayerIndex],
          layoutFields: listGroupsLayoutFields
        },
        showcase: {
          layer: this.state.webmap.layers[showcaseLayerIndex],
          layoutFields: showcaseLayoutFields
        }
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var map = L.map('react-esri-map', { center: [35, 139], zoom: 5 });
      this._initWebMap(map, this.props.mapid);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var map = this.state.map;
      map.eachLayer(function (l) {
        map.removeLayer(l);
      });
      this._initWebMap(map, nextProps.mapid);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'a',
          { href: 'https://github.com/ynunokawa/react-webmap' },
          _react2.default.createElement('img', { style: { position: 'absolute', top: 0, right: 0, border: 0, zIndex: 99999 }, src: 'https://camo.githubusercontent.com/652c5b9acfaddf3a9c326fa6bde407b87f7be0f4/68747470733a2f2f73332e616d617a6f6e6177732e636f6d2f6769746875622f726962626f6e732f666f726b6d655f72696768745f6f72616e67655f6666373630302e706e67', alt: 'Fork me on GitHub', 'data-canonical-src': 'https://s3.amazonaws.com/github/ribbons/forkme_right_orange_ff7600.png' })
        ),
        _react2.default.createElement(
          _reactBootstrap.Navbar,
          null,
          _react2.default.createElement(
            _reactBootstrap.Navbar.Header,
            null,
            _react2.default.createElement(
              _reactBootstrap.Navbar.Brand,
              null,
              _react2.default.createElement(
                'a',
                { href: '#' },
                'React WebMap'
              )
            ),
            _react2.default.createElement(_reactBootstrap.Navbar.Toggle, null)
          ),
          _react2.default.createElement(
            _reactBootstrap.Navbar.Collapse,
            null,
            _react2.default.createElement(
              _reactBootstrap.Nav,
              null,
              _react2.default.createElement(
                _reactBootstrap.NavItem,
                { eventKey: 1, href: '#mediator' },
                'Mediator'
              ),
              _react2.default.createElement(
                _reactBootstrap.NavItem,
                { eventKey: 2, href: '#mapview' },
                'MapView'
              ),
              _react2.default.createElement(
                _reactBootstrap.NavItem,
                { eventKey: 3, href: '#reactors' },
                'Reactors'
              )
            )
          )
        ),
        _react2.default.createElement(
          'style',
          { type: 'text/css' },
          '\n        .row {\n            margin-bottom: 20px;\n        }\n        '
        ),
        _react2.default.createElement(
          _reactBootstrap.Grid,
          null,
          _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { xs: 12, md: 12 },
              _react2.default.createElement(
                'h1',
                { id: 'mediator' },
                'Mediator'
              ),
              _react2.default.createElement(
                'h4',
                null,
                _react2.default.createElement(
                  'code',
                  null,
                  '<Mediator />'
                )
              )
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { xs: 12, md: 12 },
              _react2.default.createElement(
                'h3',
                { id: 'mapview' },
                'MapView'
              ),
              _react2.default.createElement(
                'h4',
                null,
                _react2.default.createElement(
                  'code',
                  null,
                  '<MapView />'
                )
              ),
              _react2.default.createElement(_MapView2.default, null)
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { xs: 12, md: 12 },
              _react2.default.createElement(
                'h3',
                { id: 'reactors' },
                'Reactors'
              ),
              _react2.default.createElement(
                'h4',
                null,
                _react2.default.createElement(
                  'code',
                  null,
                  '<HomeButton />'
                )
              ),
              _react2.default.createElement(_HomeButton2.default, {
                center: this.state.initialCenter,
                zoom: this.state.initialZoom,
                onGetHome: this.setView
              })
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { xs: 12, md: 12 },
              _react2.default.createElement(
                'h4',
                null,
                _react2.default.createElement(
                  'code',
                  null,
                  '<Bookmarks />'
                )
              ),
              _react2.default.createElement(_Bookmarks2.default, {
                bookmarks: this.state.bookmarks,
                onClickBookmark: this.fitBounds
              })
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { xs: 12, md: 12 },
              _react2.default.createElement(
                'h4',
                null,
                _react2.default.createElement(
                  'code',
                  null,
                  '<Geocoder />'
                )
              ),
              _react2.default.createElement(_Geocoder2.default, {
                onSearch: this.fitBounds
              })
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { xs: 12, md: 12 },
              _react2.default.createElement(
                'h4',
                null,
                _react2.default.createElement(
                  'code',
                  null,
                  '<LayerList />'
                )
              ),
              _react2.default.createElement(_LayerList2.default, {
                map: this.state.map,
                layers: this.state.layers
              })
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { xs: 12, md: 12 },
              _react2.default.createElement(
                'h4',
                null,
                _react2.default.createElement(
                  'code',
                  null,
                  '<ListGroups />'
                )
              ),
              _react2.default.createElement(_ListGroups2.default, {
                layer: this.state.listGroups.layer,
                layoutFields: this.state.listGroups.layoutFields,
                mapState: this.state.mapState,
                filter: true,
                onClickList: this.setView
              })
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { xs: 12, md: 12 },
              _react2.default.createElement(
                'h4',
                null,
                _react2.default.createElement(
                  'code',
                  null,
                  '<Showcase />'
                )
              ),
              _react2.default.createElement(_Showcase2.default, {
                layer: this.state.showcase.layer,
                layoutFields: this.state.showcase.layoutFields,
                mapState: this.state.mapState,
                onClickThumbnail: this.setView
              })
            )
          )
        )
      );
    }
  }]);

  return Mediator;
}(_react2.default.Component);

Mediator.propTypes = {
  mapid: _react2.default.PropTypes.string
};

Mediator.defaultProps = {
  mapid: '55e02e777274468c90745fde6641faf4'
};

Mediator.displayName = 'Mediator';

exports.default = Mediator;