'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _rcSlider = require('rc-slider');

var _rcSlider2 = _interopRequireDefault(_rcSlider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // Copyright (c) 2016 Yusuke Nunokawa (https://ynunokawa.github.io)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

var LayerItem = function (_React$Component) {
  _inherits(LayerItem, _React$Component);

  function LayerItem(props) {
    _classCallCheck(this, LayerItem);

    var _this = _possibleConstructorReturn(this, (LayerItem.__proto__ || Object.getPrototypeOf(LayerItem)).call(this, props));

    _this.state = {
      opacity: 1
    };
    _this._onChangeVisibility = _this._onChangeVisibility.bind(_this);
    _this._onChangeOpacity = _this._onChangeOpacity.bind(_this);
    return _this;
  }

  _createClass(LayerItem, [{
    key: '_onChangeVisibility',
    value: function _onChangeVisibility(e) {
      var checked = e.target.checked;
      var layer = this.props.layer.layer;
      var map = this.props.map;
      if (checked === true) {
        map.addLayer(layers[index].layer);
      } else {
        map.removeLayer(layers[index].layer);
      }
    }
  }, {
    key: '_onChangeOpacity',
    value: function _onChangeOpacity(value) {
      var pane = this.props.pane;
      pane.style.opacity = value;
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState({ opacity: this.props.initialOpacity });
    }
  }, {
    key: 'render',
    value: function render() {
      var name = this.props.name;
      var opacity = this.state.opacity;
      var layer = this.props.layer;
      var map = this.props.map;

      if (map.hasLayer(layer.layer)) {
        return _react2.default.createElement(
          _reactBootstrap.ListGroupItem,
          null,
          _react2.default.createElement(
            _reactBootstrap.Checkbox,
            { onChange: this._onChangeVisibility, defaultChecked: true },
            name
          ),
          _react2.default.createElement(_rcSlider2.default, { min: 0, max: 1, step: 0.01, defaultValue: opacity, onChange: this._onChangeOpacity })
        );
      } else {
        return _react2.default.createElement(
          _reactBootstrap.ListGroupItem,
          null,
          _react2.default.createElement(
            _reactBootstrap.Checkbox,
            { onChange: this._onChangeVisibility },
            name
          ),
          _react2.default.createElement(_rcSlider2.default, { min: 0, max: 1, step: 0.01, defaultValue: opacity, onChange: this._onChangeOpacity })
        );
      }
    }
  }]);

  return LayerItem;
}(_react2.default.Component);

LayerItem.propTypes = {
  name: _react2.default.PropTypes.string,
  layer: _react2.default.PropTypes.object,
  pane: _react2.default.PropTypes.object,
  initialOpacity: _react2.default.PropTypes.number,
  map: _react2.default.PropTypes.any.isRequired
};

LayerItem.displayName = 'LayerItem';

exports.default = LayerItem;