'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _rcSlider = require('rc-slider');

var _rcSlider2 = _interopRequireDefault(_rcSlider);

var _LayerItem = require('./LayerItem');

var _LayerItem2 = _interopRequireDefault(_LayerItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // Copyright (c) 2016 Yusuke Nunokawa (https://ynunokawa.github.io)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

var LayerList = function (_React$Component) {
  _inherits(LayerList, _React$Component);

  function LayerList(props) {
    _classCallCheck(this, LayerList);

    return _possibleConstructorReturn(this, (LayerList.__proto__ || Object.getPrototypeOf(LayerList)).call(this, props));
  }

  _createClass(LayerList, [{
    key: 'render',
    value: function render() {
      var map = this.props.map;
      var layers = this.props.layers;
      var headerText = this.props.headerText;

      var layerList = layers.map(function (l, i) {
        var opacity = 1;
        var pane = void 0;
        if (i == 0) {
          pane = document.getElementsByClassName('leaflet-tile-pane')[0];
        } else {
          pane = document.getElementsByClassName('leaflet-esri-webmap-layer' + (i - 1) + '-pane')[0];
        }
        if (pane.style.opacity !== undefined && pane.style.opacity !== null && pane.style.opacity !== '') {
          opacity = Number(pane.style.opacity);
        }
        return _react2.default.createElement(_LayerItem2.default, {
          name: l.title,
          layer: l,
          pane: pane,
          initialOpacity: opacity,
          map: map,
          key: l.title + i
        });
      }.bind(this));

      return _react2.default.createElement(
        _reactBootstrap.ListGroup,
        null,
        _react2.default.createElement(
          _reactBootstrap.ListGroupItem,
          { active: true },
          headerText
        ),
        _react2.default.createElement(
          'style',
          { type: 'text/css' },
          '\n        .checkbox {\n            margin-top: 0;\n            margin-bottom: 0;\n            display: inline-block;\n            width: 80%;\n        }\n        .rc-slider {\n            display: inline-block;\n            width: 20%;\n        }\n        .list-group-item.active {\n            z-index: 0;\n        }\n        '
        ),
        layerList
      );
    }
  }]);

  return LayerList;
}(_react2.default.Component);

LayerList.propTypes = {
  map: _react2.default.PropTypes.any.isRequired,
  layers: _react2.default.PropTypes.array,
  headerText: _react2.default.PropTypes.string
};

LayerList.defaultProps = {
  layers: [],
  headerText: 'Layer List'
};

LayerList.displayName = 'LayerList';

exports.default = LayerList;