'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // Copyright (c) 2016 Yusuke Nunokawa (https://ynunokawa.github.io)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

var ItemThumbnail = function (_React$Component) {
  _inherits(ItemThumbnail, _React$Component);

  function ItemThumbnail(props) {
    _classCallCheck(this, ItemThumbnail);

    var _this = _possibleConstructorReturn(this, (ItemThumbnail.__proto__ || Object.getPrototypeOf(ItemThumbnail)).call(this, props));

    _this._onClickThumbnail = _this._onClickThumbnail.bind(_this);
    return _this;
  }

  _createClass(ItemThumbnail, [{
    key: '_onClickThumbnail',
    value: function _onClickThumbnail() {
      var feature = this.props.feature;
      this.props.onClickThumbnail(feature.geometry.coordinates.reverse(), 15);
    }
  }, {
    key: 'render',
    value: function render() {
      var feature = this.props.feature;
      var layoutFields = this.props.layoutFields;
      var imageUrl = feature.properties[layoutFields.image];
      var name = feature.properties[layoutFields.name];
      var description = feature.properties[layoutFields.description];

      if (layoutFields.imageUrlPrefix !== undefined && layoutFields.imageUrlPrefix !== '') {
        imageUrl = layoutFields.imageUrlPrefix + imageUrl;
      }

      return _react2.default.createElement(
        _reactBootstrap.Thumbnail,
        { src: imageUrl, onClick: this._onClickThumbnail, className: 'react-webmap-item-thumbnail' },
        _react2.default.createElement(
          'h3',
          null,
          name
        ),
        _react2.default.createElement(
          'p',
          null,
          description
        )
      );
    }
  }]);

  return ItemThumbnail;
}(_react2.default.Component);

ItemThumbnail.propTypes = {
  feature: _react2.default.PropTypes.any,
  layoutFields: _react2.default.PropTypes.object,
  onClickThumbnail: _react2.default.PropTypes.func
};

ItemThumbnail.displayName = 'ItemThumbnail';

exports.default = ItemThumbnail;