'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _ItemThumbnail = require('./ItemThumbnail');

var _ItemThumbnail2 = _interopRequireDefault(_ItemThumbnail);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // Copyright (c) 2016 Yusuke Nunokawa (https://ynunokawa.github.io)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

var Showcase = function (_React$Component) {
  _inherits(Showcase, _React$Component);

  function Showcase(props) {
    _classCallCheck(this, Showcase);

    return _possibleConstructorReturn(this, (Showcase.__proto__ || Object.getPrototypeOf(Showcase)).call(this, props));
  }

  _createClass(Showcase, [{
    key: 'render',
    value: function render() {
      var layer = this.props.layer;
      var layoutFields = this.props.layoutFields;
      var bounds = this.props.mapState.bounds;

      var features = [];
      var lyr = null;

      if (layer.layer !== undefined) {
        Object.keys(layer.layer._layers).map(function (k) {
          if (layer.layer._layers[k]._cache !== undefined) {
            lyr = layer.layer._layers[k];
          }
        });
        if (lyr !== null) {
          lyr.eachFeature(function (l) {
            if (bounds.contains(l._latlng)) {
              features.push(l.feature);
            }
          });
        }
        features = features.sort(function (a, b) {
          return b.properties[layoutFields.sort] - a.properties[layoutFields.sort];
        });
      }

      var ItemThumbnails = features.map(function (f, i) {
        return _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 12, sm: 6, md: 4, key: f.properties[layoutFields.name] + i },
          _react2.default.createElement(_ItemThumbnail2.default, {
            feature: features[i],
            layoutFields: layoutFields,
            onClickThumbnail: this.props.onClickThumbnail
          })
        );
      }.bind(this));

      return _react2.default.createElement(
        _reactBootstrap.Grid,
        null,
        _react2.default.createElement(
          _reactBootstrap.Row,
          null,
          _react2.default.createElement(
            'style',
            { type: 'text/css' },
            '\n            .react-webmap-item-thumbnail {\n                padding: 0;\n                overflow: hidden;\n            }\n            .react-webmap-item-thumbnail > img {\n                border-radius: 4px 4px 0 0;\n                cursor: pointer;\n                transition: opacity 0.3s;\n            }\n            .react-webmap-item-thumbnail > img:hover {\n                opacity: 0.8\n            }\n            .react-webmap-item-thumbnail > div.caption {\n                margin-left: 5px;\n            }\n            '
          ),
          ItemThumbnails
        )
      );
    }
  }]);

  return Showcase;
}(_react2.default.Component);

Showcase.propTypes = {
  layer: _react2.default.PropTypes.object,
  layoutFields: _react2.default.PropTypes.object,
  mapState: _react2.default.PropTypes.object,
  onClickThumbnail: _react2.default.PropTypes.func
};

Showcase.displayName = 'Showcase';

exports.default = Showcase;